var $CLJS = require("./cljs_env");
var $jscomp = $CLJS.$jscomp;
require("./cljs.core.js");
require("./shadow.js.shim.module$net.js");
require("./shadow.js.shim.module$bencode.js");
require("./shadow.js.shim.module$buffer.js");
require("./clojure.string.js");
require("./calva.js_utils.js");
var clojure=$CLJS.clojure;
var cljs=$CLJS.cljs;
var shadow=$CLJS.shadow;
var goog=$CLJS.goog;
var calva=$CLJS.calva;

$CLJS.SHADOW_ENV.setLoaded("calva.repl.nrepl.js");

goog.provide('calva.repl.nrepl');
goog.require('cljs.core');
goog.require('shadow.js.shim.module$net');
goog.require('shadow.js.shim.module$bencode');
goog.require('shadow.js.shim.module$buffer');
goog.require('clojure.string');
goog.require('calva.js_utils');
calva.repl.nrepl.CONTINUATION_ERROR_MESSAGE = "Unexpected continuation: \"";
/**
 * Connects to a socket-based REPL at the given host (defaults to localhost) and port.
 */
calva.repl.nrepl.connect = (function calva$repl$nrepl$connect(p__10281){
var map__10284 = p__10281;
var map__10284__$1 = (((((!((map__10284 == null))))?(((((map__10284.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__10284.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__10284):map__10284);
var host = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__10284__$1,new cljs.core.Keyword(null,"host","host",-1558485167),"localhost");
var port = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__10284__$1,new cljs.core.Keyword(null,"port","port",1534937262));
var on_connect = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__10284__$1,new cljs.core.Keyword(null,"on-connect","on-connect",-1148973056));
var on_error = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__10284__$1,new cljs.core.Keyword(null,"on-error","on-error",1728533530));
var on_end = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__10284__$1,new cljs.core.Keyword(null,"on-end","on-end",1933704364));
var G__10294 = (function (){var G__10295 = ({"host": host, "port": port});
return shadow.js.shim.module$net.createConnection(G__10295);
})();
G__10294.once("connect",(function (){
if(cljs.core.truth_(on_connect)){
return (on_connect.cljs$core$IFn$_invoke$arity$0 ? on_connect.cljs$core$IFn$_invoke$arity$0() : on_connect.call(null));
} else {
return null;
}
}));

G__10294.once("end",(function (){
if(cljs.core.truth_(on_end)){
return (on_end.cljs$core$IFn$_invoke$arity$0 ? on_end.cljs$core$IFn$_invoke$arity$0() : on_end.call(null));
} else {
return null;
}
}));

G__10294.once("error",(function (error){
console.log(["Failed to connect to ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(host),":",cljs.core.str.cljs$core$IFn$_invoke$arity$1(port)].join(''),error);

if(cljs.core.truth_(on_error)){
return (on_error.cljs$core$IFn$_invoke$arity$1 ? on_error.cljs$core$IFn$_invoke$arity$1(error) : on_error.call(null,error));
} else {
return null;
}
}));

return G__10294;
});
calva.repl.nrepl.decode = (function calva$repl$nrepl$decode(buffers){
return cljs.core.mapcat.cljs$core$IFn$_invoke$arity$variadic((function (buffer){
try{return (new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(shadow.js.shim.module$bencode.decode(buffer),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.Keyword(null,"keywordize-keys","keywordize-keys",1310784252),true], 0))],null));
}catch (e10312){if((e10312 instanceof Error)){
var e = e10312;
var exception_message = e.message;
if(clojure.string.includes_QMARK_(exception_message,calva.repl.nrepl.CONTINUATION_ERROR_MESSAGE)){
var recoverable_content = cljs.core.subs.cljs$core$IFn$_invoke$arity$2(exception_message,cljs.core.count(calva.repl.nrepl.CONTINUATION_ERROR_MESSAGE));
var recoverable_buffer = buffer.slice((0),(buffer.length - cljs.core.count(recoverable_content)));
var G__10320 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [recoverable_buffer,shadow.js.shim.module$buffer.Buffer.from(recoverable_content)], null);
return (calva.repl.nrepl.decode.cljs$core$IFn$_invoke$arity$1 ? calva.repl.nrepl.decode.cljs$core$IFn$_invoke$arity$1(G__10320) : calva.repl.nrepl.decode.call(null,G__10320));
} else {
return console.error("FAILED TO DECODE",exception_message);
}
} else {
throw e10312;

}
}}),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([buffers], 0));
});
calva.repl.nrepl._STAR_results = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
calva.repl.nrepl.message = (function calva$repl$nrepl$message(conn,msg,callback){
var id = cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.random_uuid());
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(calva.repl.nrepl._STAR_results,cljs.core.assoc,id,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"callback","callback",-705136228),callback,new cljs.core.Keyword(null,"msg","msg",-1386103444),msg,new cljs.core.Keyword(null,"results","results",-1134170113),cljs.core.PersistentVector.EMPTY], null));

conn.on("data",(function (chunk){
var temp__5457__auto__ = (function (){var empty_buffer = shadow.js.shim.module$buffer.Buffer.from("");
var buffer = (function (){var G__10450 = calva.js_utils.jsify(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [empty_buffer,chunk], null));
return shadow.js.shim.module$buffer.Buffer.concat(G__10450);
})();
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((0),buffer.length)){
console.warn("EMPTY BUFFER");
} else {
}

return cljs.core.not_empty(calva.repl.nrepl.decode(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [buffer], null)));
})();
if(cljs.core.truth_(temp__5457__auto__)){
var decoded_messages = temp__5457__auto__;
cljs.core.dorun.cljs$core$IFn$_invoke$arity$1(cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (decoded_messages,temp__5457__auto__){
return (function (decoded){
var temp__5457__auto____$1 = new cljs.core.Keyword(null,"id","id",-1388402092).cljs$core$IFn$_invoke$arity$1(decoded);
if(cljs.core.truth_(temp__5457__auto____$1)){
var d_id = temp__5457__auto____$1;
var cb = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(calva.repl.nrepl._STAR_results),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [d_id,new cljs.core.Keyword(null,"callback","callback",-705136228)], null));
var results = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$variadic(calva.repl.nrepl._STAR_results,cljs.core.update_in,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [d_id,new cljs.core.Keyword(null,"results","results",-1134170113)], null),cljs.core.fnil.cljs$core$IFn$_invoke$arity$2(cljs.core.conj,cljs.core.PersistentVector.EMPTY),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([decoded], 0)),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [d_id,new cljs.core.Keyword(null,"results","results",-1134170113)], null));
if(cljs.core.truth_(cljs.core.some(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, ["done",null], null), null),new cljs.core.Keyword(null,"status","status",-1997798413).cljs$core$IFn$_invoke$arity$1(decoded)))){
cljs.core.println.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["*results cb",cljs.core.deref(calva.repl.nrepl._STAR_results)], 0))], 0));

cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(calva.repl.nrepl._STAR_results,cljs.core.dissoc,d_id);

var G__10476 = calva.js_utils.jsify(results);
return (cb.cljs$core$IFn$_invoke$arity$1 ? cb.cljs$core$IFn$_invoke$arity$1(G__10476) : cb.call(null,G__10476));
} else {
return null;
}
} else {
return null;
}
});})(decoded_messages,temp__5457__auto__))
,decoded_messages));

return cljs.core.println.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["*results pending",cljs.core.deref(calva.repl.nrepl._STAR_results)], 0))], 0));
} else {
return null;
}
}));

return conn.write((function (){var G__10532 = calva.js_utils.jsify(cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(msg,new cljs.core.Keyword(null,"id","id",-1388402092),id));
return shadow.js.shim.module$bencode.encode(G__10532);
})(),"binary");
});

module.exports = calva.repl.nrepl;

//# sourceMappingURL=calva.repl.nrepl.js.map
