var $CLJS = require("./cljs_env");
var $jscomp = $CLJS.$jscomp;
require("./cljs.core.js");
require("./oops.core.js");
require("./shadow.js.shim.module$bencode.js");
var cljs=$CLJS.cljs;
var shadow=$CLJS.shadow;
var goog=$CLJS.goog;
var oops=$CLJS.oops;
var clojure_party_repl=$CLJS.clojure_party_repl || ($CLJS.clojure_party_repl = {});
$CLJS.SHADOW_ENV.setLoaded("clojure_party_repl.bencode.js");

goog.provide('clojure_party_repl.bencode');
goog.require('cljs.core');
goog.require('oops.core');
goog.require('shadow.js.shim.module$bencode');
clojure_party_repl.bencode.reset_decode_data = (function clojure_party_repl$bencode$reset_decode_data(){
var target_obj_14753_14842 = shadow.js.shim.module$bencode.decode;
var _STAR_runtime_state_STAR__orig_val__14757_14843 = oops.state._STAR_runtime_state_STAR_;
var _STAR_runtime_state_STAR__temp_val__14758_14844 = oops.state.prepare_state(target_obj_14753_14842,(new Error()),function(){arguments[0].apply(console,Array.prototype.slice.call(arguments,1))});
oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__temp_val__14758_14844;

try{var parent_obj_14756_14845 = target_obj_14753_14842;
if(oops.core.validate_object_access_dynamically(parent_obj_14756_14845,(0),"data",true,true,true)){
(parent_obj_14756_14845["data"] = null);
} else {
}

}finally {oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__orig_val__14757_14843;
}
var target_obj_14759_14847 = shadow.js.shim.module$bencode.decode;
var _STAR_runtime_state_STAR__orig_val__14761_14850 = oops.state._STAR_runtime_state_STAR_;
var _STAR_runtime_state_STAR__temp_val__14762_14851 = oops.state.prepare_state(target_obj_14759_14847,(new Error()),function(){arguments[0].apply(console,Array.prototype.slice.call(arguments,1))});
oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__temp_val__14762_14851;

try{var parent_obj_14760_14854 = target_obj_14759_14847;
if(oops.core.validate_object_access_dynamically(parent_obj_14760_14854,(0),"encoding",true,true,true)){
(parent_obj_14760_14854["encoding"] = null);
} else {
}

}finally {oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__orig_val__14761_14850;
}
var target_obj_14763 = shadow.js.shim.module$bencode.decode;
var _STAR_runtime_state_STAR__orig_val__14765 = oops.state._STAR_runtime_state_STAR_;
var _STAR_runtime_state_STAR__temp_val__14766 = oops.state.prepare_state(target_obj_14763,(new Error()),function(){arguments[0].apply(console,Array.prototype.slice.call(arguments,1))});
oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__temp_val__14766;

try{var parent_obj_14764_14859 = target_obj_14763;
if(oops.core.validate_object_access_dynamically(parent_obj_14764_14859,(0),"position",true,true,true)){
(parent_obj_14764_14859["position"] = (0));
} else {
}

return target_obj_14763;
}finally {oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__orig_val__14765;
}});
/**
 * Returns a decoded data when it succeeds to decode. Returns nil when there's
 *   no more data to be decoded or when there's only partial data.
 */
clojure_party_repl.bencode.decode_next = (function clojure_party_repl$bencode$decode_next(){
var previous_position = shadow.js.shim.module$bencode.decode.position;
try{return shadow.js.shim.module$bencode.decode.next();
}catch (e14767){if((e14767 instanceof Error)){
var e = e14767;
if((shadow.js.shim.module$bencode.decode.position > shadow.js.shim.module$bencode.decode.data.length)){
var target_obj_14768_14860 = shadow.js.shim.module$bencode.decode;
var _STAR_runtime_state_STAR__orig_val__14770_14861 = oops.state._STAR_runtime_state_STAR_;
var _STAR_runtime_state_STAR__temp_val__14771_14862 = oops.state.prepare_state(target_obj_14768_14860,(new Error()),function(){arguments[0].apply(console,Array.prototype.slice.call(arguments,1))});
oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__temp_val__14771_14862;

try{var parent_obj_14769_14863 = target_obj_14768_14860;
if(oops.core.validate_object_access_dynamically(parent_obj_14769_14863,(0),"position",true,true,true)){
(parent_obj_14769_14863["position"] = previous_position);
} else {
}

}finally {oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__orig_val__14770_14861;
}} else {
}

return console.log("Caught ",e);
} else {
throw e14767;

}
}});
/**
 * Returns a vector of decoded data that was possible to decode as far as
 *   it could.
 */
clojure_party_repl.bencode.decode_all = (function clojure_party_repl$bencode$decode_all(){
var all_data = cljs.core.PersistentVector.EMPTY;
while(true){
var temp__5455__auto__ = clojure_party_repl.bencode.decode_next();
if(cljs.core.truth_(temp__5455__auto__)){
var decoded_data = temp__5455__auto__;
var G__14864 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(all_data,decoded_data);
all_data = G__14864;
continue;
} else {
return all_data;
}
break;
}
});
/**
 * Returns a vector of decoded-data after concatinating the new data onto the
 *   previous data.
 */
clojure_party_repl.bencode.concat_data_and_decode = (function clojure_party_repl$bencode$concat_data_and_decode(data){
console.log("Concat and decode...");

var new_data = Buffer.concat((new Array(shadow.js.shim.module$bencode.decode.data,(new Buffer(data)))));
var target_obj_14772_14865 = shadow.js.shim.module$bencode.decode;
var _STAR_runtime_state_STAR__orig_val__14774_14866 = oops.state._STAR_runtime_state_STAR_;
var _STAR_runtime_state_STAR__temp_val__14775_14867 = oops.state.prepare_state(target_obj_14772_14865,(new Error()),function(){arguments[0].apply(console,Array.prototype.slice.call(arguments,1))});
oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__temp_val__14775_14867;

try{var parent_obj_14773_14868 = target_obj_14772_14865;
if(oops.core.validate_object_access_dynamically(parent_obj_14773_14868,(0),"data",true,true,true)){
(parent_obj_14773_14868["data"] = new_data);
} else {
}

}finally {oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__orig_val__14774_14866;
}
return clojure_party_repl.bencode.decode_all();
});
clojure_party_repl.bencode.decoded_all_QMARK_ = (function clojure_party_repl$bencode$decoded_all_QMARK_(){
console.log("Decoded All?: ",(cljs.core.truth_(shadow.js.shim.module$bencode.decode.data)?shadow.js.shim.module$bencode.decode.data.length:null),(cljs.core.truth_(shadow.js.shim.module$bencode.decode.data)?shadow.js.shim.module$bencode.decode.position:null));

return (((shadow.js.shim.module$bencode.decode.data == null)) || (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(shadow.js.shim.module$bencode.decode.data.length,shadow.js.shim.module$bencode.decode.position)));
});
clojure_party_repl.bencode.get_decode_data = (function clojure_party_repl$bencode$get_decode_data(){
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"data","data",-232669377),(function (){var target_obj_14777 = shadow.js.shim.module$bencode.decode;
var _STAR_runtime_state_STAR__orig_val__14779 = oops.state._STAR_runtime_state_STAR_;
var _STAR_runtime_state_STAR__temp_val__14780 = oops.state.prepare_state(target_obj_14777,(new Error()),function(){arguments[0].apply(console,Array.prototype.slice.call(arguments,1))});
oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__temp_val__14780;

try{var next_obj_14778 = ((oops.core.validate_object_access_dynamically(target_obj_14777,(0),"data",true,true,false))?(target_obj_14777["data"]):null);
return next_obj_14778;
}finally {oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__orig_val__14779;
}})(),new cljs.core.Keyword(null,"position","position",-2011731912),(function (){var target_obj_14781 = shadow.js.shim.module$bencode.decode;
var _STAR_runtime_state_STAR__orig_val__14783 = oops.state._STAR_runtime_state_STAR_;
var _STAR_runtime_state_STAR__temp_val__14784 = oops.state.prepare_state(target_obj_14781,(new Error()),function(){arguments[0].apply(console,Array.prototype.slice.call(arguments,1))});
oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__temp_val__14784;

try{var next_obj_14782 = ((oops.core.validate_object_access_dynamically(target_obj_14781,(0),"position",true,true,false))?(target_obj_14781["position"]):null);
return next_obj_14782;
}finally {oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__orig_val__14783;
}})(),new cljs.core.Keyword(null,"encoding","encoding",1728578272),(function (){var target_obj_14785 = shadow.js.shim.module$bencode.decode;
var _STAR_runtime_state_STAR__orig_val__14787 = oops.state._STAR_runtime_state_STAR_;
var _STAR_runtime_state_STAR__temp_val__14788 = oops.state.prepare_state(target_obj_14785,(new Error()),function(){arguments[0].apply(console,Array.prototype.slice.call(arguments,1))});
oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__temp_val__14788;

try{var next_obj_14786 = ((oops.core.validate_object_access_dynamically(target_obj_14785,(0),"encoding",true,true,false))?(target_obj_14785["encoding"]):null);
return next_obj_14786;
}finally {oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__orig_val__14787;
}})()], null);
});
/**
 * Sets the given decode data as the bencode state if the data has not been
 *   fully decoded.
 */
clojure_party_repl.bencode.apply_decode_data = (function clojure_party_repl$bencode$apply_decode_data(p__14798){
var map__14799 = p__14798;
var map__14799__$1 = (((((!((map__14799 == null))))?(((((map__14799.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__14799.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__14799):map__14799);
var data = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__14799__$1,new cljs.core.Keyword(null,"data","data",-232669377));
var position = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__14799__$1,new cljs.core.Keyword(null,"position","position",-2011731912));
var encoding = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__14799__$1,new cljs.core.Keyword(null,"encoding","encoding",1728578272));
console.log("Applying decode data...");

if(cljs.core.truth_((function (){var and__4036__auto__ = data;
if(cljs.core.truth_(and__4036__auto__)){
var and__4036__auto____$1 = position;
if(cljs.core.truth_(and__4036__auto____$1)){
return cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(data.length,position);
} else {
return and__4036__auto____$1;
}
} else {
return and__4036__auto__;
}
})())){
var target_obj_14801_14873 = shadow.js.shim.module$bencode.decode;
var _STAR_runtime_state_STAR__orig_val__14806_14874 = oops.state._STAR_runtime_state_STAR_;
var _STAR_runtime_state_STAR__temp_val__14807_14875 = oops.state.prepare_state(target_obj_14801_14873,(new Error()),function(){arguments[0].apply(console,Array.prototype.slice.call(arguments,1))});
oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__temp_val__14807_14875;

try{var parent_obj_14802_14876 = target_obj_14801_14873;
if(oops.core.validate_object_access_dynamically(parent_obj_14802_14876,(0),"data",true,true,true)){
(parent_obj_14802_14876["data"] = data);
} else {
}

}finally {oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__orig_val__14806_14874;
}
var target_obj_14814_14877 = shadow.js.shim.module$bencode.decode;
var _STAR_runtime_state_STAR__orig_val__14816_14878 = oops.state._STAR_runtime_state_STAR_;
var _STAR_runtime_state_STAR__temp_val__14817_14879 = oops.state.prepare_state(target_obj_14814_14877,(new Error()),function(){arguments[0].apply(console,Array.prototype.slice.call(arguments,1))});
oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__temp_val__14817_14879;

try{var parent_obj_14815_14880 = target_obj_14814_14877;
if(oops.core.validate_object_access_dynamically(parent_obj_14815_14880,(0),"position",true,true,true)){
(parent_obj_14815_14880["position"] = position);
} else {
}

}finally {oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__orig_val__14816_14878;
}
var target_obj_14823_14881 = shadow.js.shim.module$bencode.decode;
var _STAR_runtime_state_STAR__orig_val__14829_14882 = oops.state._STAR_runtime_state_STAR_;
var _STAR_runtime_state_STAR__temp_val__14830_14883 = oops.state.prepare_state(target_obj_14823_14881,(new Error()),function(){arguments[0].apply(console,Array.prototype.slice.call(arguments,1))});
oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__temp_val__14830_14883;

try{var parent_obj_14826_14884 = target_obj_14823_14881;
if(oops.core.validate_object_access_dynamically(parent_obj_14826_14884,(0),"encoding",true,true,true)){
(parent_obj_14826_14884["encoding"] = encoding);
} else {
}

}finally {oops.state._STAR_runtime_state_STAR_ = _STAR_runtime_state_STAR__orig_val__14829_14882;
}
return console.log("Applied data: ",shadow.js.shim.module$bencode.decode.data.length,shadow.js.shim.module$bencode.decode.position);
} else {
return null;
}
});
/**
 * Returns a vector of decoded data in case the encoded data includes multiple
 *   data chunks. It needs to be in a try-catch block because it can throw when
 *   the given data is empty, partial data, or invalid data.
 *   'decode' object holds two states: the data to be decoded and the position to
 *   start decoding next. The position gets updated when decode.next() succeeds.
 *   Because of these states, we need to handle two different cases:
 *  1. bencode.decode() is called the first time or when all the previous data
 *     has been decoded (meaning the position is at the last index), so we can
 *     override the previous data and just call bencode.decode() again.
 *  2. The previous data is only partially decoded, so the new data needs
 *     to be concatinated onto the previous data before decoding.
 */
clojure_party_repl.bencode.decode = (function clojure_party_repl$bencode$decode(data){
if(clojure_party_repl.bencode.decoded_all_QMARK_()){
try{clojure_party_repl.bencode.apply_decode_data(new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"data","data",-232669377),data,new cljs.core.Keyword(null,"position","position",-2011731912),(0),new cljs.core.Keyword(null,"encoding","encoding",1728578272),"utf8"], null));

return clojure_party_repl.bencode.decode_all();
}catch (e14840){if((e14840 instanceof Error)){
var e = e14840;
return console.log("Caught Error during decoding: ",e);
} else {
throw e14840;

}
}} else {
return clojure_party_repl.bencode.concat_data_and_decode(data);
}
});
/**
 * Encodes the given data using bencode.
 */
clojure_party_repl.bencode.encode = (function clojure_party_repl$bencode$encode(data){
try{return shadow.js.shim.module$bencode.encode(data,"binary");
}catch (e14841){if((e14841 instanceof Error)){
var e = e14841;
return console.log("Failed encoding because of ",e);
} else {
throw e14841;

}
}});

module.exports = clojure_party_repl.bencode;

//# sourceMappingURL=clojure_party_repl.bencode.js.map
