var $CLJS = require("./cljs_env");
var $jscomp = $CLJS.$jscomp;
require("./cljs.core.js");
require("./shadow.cljs.devtools.client.env.js");
require("./shadow.js.shim.module$ws.js");
require("./cljs.reader.js");
require("./goog.object.object.js");
var cljs=$CLJS.cljs;
var shadow=$CLJS.shadow;
var goog=$CLJS.goog;

$CLJS.SHADOW_ENV.setLoaded("shadow.cljs.devtools.client.node.js");

goog.provide('shadow.cljs.devtools.client.node');
goog.require('cljs.core');
goog.require('shadow.cljs.devtools.client.env');
goog.require('shadow.js.shim.module$ws');
goog.require('cljs.reader');
goog.require('goog.object');
if((typeof shadow !== 'undefined') && (typeof shadow.cljs !== 'undefined') && (typeof shadow.cljs.devtools !== 'undefined') && (typeof shadow.cljs.devtools.client !== 'undefined') && (typeof shadow.cljs.devtools.client.node !== 'undefined') && (typeof shadow.cljs.devtools.client.node.client_id !== 'undefined')){
} else {
shadow.cljs.devtools.client.node.client_id = cljs.core.random_uuid();
}
if((typeof shadow !== 'undefined') && (typeof shadow.cljs !== 'undefined') && (typeof shadow.cljs.devtools !== 'undefined') && (typeof shadow.cljs.devtools.client !== 'undefined') && (typeof shadow.cljs.devtools.client.node !== 'undefined') && (typeof shadow.cljs.devtools.client.node.ws_ref !== 'undefined')){
} else {
shadow.cljs.devtools.client.node.ws_ref = cljs.core.volatile_BANG_(null);
}
shadow.cljs.devtools.client.node.ws_close = (function shadow$cljs$devtools$client$node$ws_close(){
var temp__5461__auto__ = cljs.core.deref(shadow.cljs.devtools.client.node.ws_ref);
if((temp__5461__auto__ == null)){
return null;
} else {
var tcp = temp__5461__auto__;
tcp.close();

return cljs.core.vreset_BANG_(shadow.cljs.devtools.client.node.ws_ref,null);
}
});
shadow.cljs.devtools.client.node.ws_msg = (function shadow$cljs$devtools$client$node$ws_msg(msg){
var temp__5461__auto__ = cljs.core.deref(shadow.cljs.devtools.client.node.ws_ref);
if((temp__5461__auto__ == null)){
return null;
} else {
var ws = temp__5461__auto__;
return ws.send(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([msg], 0)),(function (err){
if(cljs.core.truth_(err)){
return console.error("REPL msg send failed",err);
} else {
return null;
}
}));
}
});
shadow.cljs.devtools.client.node.node_eval = (function shadow$cljs$devtools$client$node$node_eval(p__22886){
var map__22891 = p__22886;
var map__22891__$1 = (((((!((map__22891 == null))))?(((((map__22891.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__22891.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__22891):map__22891);
var msg = map__22891__$1;
var js = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22891__$1,new cljs.core.Keyword(null,"js","js",1768080579));
var source_map_json = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22891__$1,new cljs.core.Keyword(null,"source-map-json","source-map-json",-299460036));
var result = SHADOW_NODE_EVAL(js,source_map_json);
return result;
});
shadow.cljs.devtools.client.node.is_loaded_QMARK_ = (function shadow$cljs$devtools$client$node$is_loaded_QMARK_(src){
return goog.object.get(SHADOW_IMPORTED,src) === true;
});
shadow.cljs.devtools.client.node.closure_import = (function shadow$cljs$devtools$client$node$closure_import(src){
if(typeof src === 'string'){
} else {
throw (new Error("Assert failed: (string? src)"));
}

return SHADOW_IMPORT(src);
});
shadow.cljs.devtools.client.node.repl_init = (function shadow$cljs$devtools$client$node$repl_init(p__22903){
var map__22905 = p__22903;
var map__22905__$1 = (((((!((map__22905 == null))))?(((((map__22905.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__22905.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__22905):map__22905);
var msg = map__22905__$1;
var id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22905__$1,new cljs.core.Keyword(null,"id","id",-1388402092));
var repl_state = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22905__$1,new cljs.core.Keyword(null,"repl-state","repl-state",-1733780387));
var map__22907 = repl_state;
var map__22907__$1 = (((((!((map__22907 == null))))?(((((map__22907.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__22907.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__22907):map__22907);
var repl_sources = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22907__$1,new cljs.core.Keyword(null,"repl-sources","repl-sources",723867535));
var seq__22911_23155 = cljs.core.seq(repl_sources);
var chunk__22913_23156 = null;
var count__22914_23157 = (0);
var i__22915_23158 = (0);
while(true){
if((i__22915_23158 < count__22914_23157)){
var map__22917_23165 = chunk__22913_23156.cljs$core$IIndexed$_nth$arity$2(null,i__22915_23158);
var map__22917_23166__$1 = (((((!((map__22917_23165 == null))))?(((((map__22917_23165.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__22917_23165.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__22917_23165):map__22917_23165);
var src_23167 = map__22917_23166__$1;
var output_name_23168 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22917_23166__$1,new cljs.core.Keyword(null,"output-name","output-name",-1769107767));
if((!(shadow.cljs.devtools.client.node.is_loaded_QMARK_(output_name_23168)))){
shadow.cljs.devtools.client.node.closure_import(output_name_23168);


var G__23177 = seq__22911_23155;
var G__23178 = chunk__22913_23156;
var G__23179 = count__22914_23157;
var G__23180 = (i__22915_23158 + (1));
seq__22911_23155 = G__23177;
chunk__22913_23156 = G__23178;
count__22914_23157 = G__23179;
i__22915_23158 = G__23180;
continue;
} else {
var G__23182 = seq__22911_23155;
var G__23183 = chunk__22913_23156;
var G__23184 = count__22914_23157;
var G__23185 = (i__22915_23158 + (1));
seq__22911_23155 = G__23182;
chunk__22913_23156 = G__23183;
count__22914_23157 = G__23184;
i__22915_23158 = G__23185;
continue;
}
} else {
var temp__5457__auto___23187 = cljs.core.seq(seq__22911_23155);
if(temp__5457__auto___23187){
var seq__22911_23190__$1 = temp__5457__auto___23187;
if(cljs.core.chunked_seq_QMARK_(seq__22911_23190__$1)){
var c__4461__auto___23191 = cljs.core.chunk_first(seq__22911_23190__$1);
var G__23193 = cljs.core.chunk_rest(seq__22911_23190__$1);
var G__23194 = c__4461__auto___23191;
var G__23195 = cljs.core.count(c__4461__auto___23191);
var G__23196 = (0);
seq__22911_23155 = G__23193;
chunk__22913_23156 = G__23194;
count__22914_23157 = G__23195;
i__22915_23158 = G__23196;
continue;
} else {
var map__22923_23200 = cljs.core.first(seq__22911_23190__$1);
var map__22923_23201__$1 = (((((!((map__22923_23200 == null))))?(((((map__22923_23200.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__22923_23200.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__22923_23200):map__22923_23200);
var src_23202 = map__22923_23201__$1;
var output_name_23203 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22923_23201__$1,new cljs.core.Keyword(null,"output-name","output-name",-1769107767));
if((!(shadow.cljs.devtools.client.node.is_loaded_QMARK_(output_name_23203)))){
shadow.cljs.devtools.client.node.closure_import(output_name_23203);


var G__23207 = cljs.core.next(seq__22911_23190__$1);
var G__23208 = null;
var G__23209 = (0);
var G__23210 = (0);
seq__22911_23155 = G__23207;
chunk__22913_23156 = G__23208;
count__22914_23157 = G__23209;
i__22915_23158 = G__23210;
continue;
} else {
var G__23211 = cljs.core.next(seq__22911_23190__$1);
var G__23212 = null;
var G__23213 = (0);
var G__23214 = (0);
seq__22911_23155 = G__23211;
chunk__22913_23156 = G__23212;
count__22914_23157 = G__23213;
i__22915_23158 = G__23214;
continue;
}
}
} else {
}
}
break;
}

return shadow.cljs.devtools.client.node.ws_msg(new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword("repl","init-complete","repl/init-complete",-162252879),new cljs.core.Keyword(null,"id","id",-1388402092),id], null));
});
shadow.cljs.devtools.client.node.repl_invoke = (function shadow$cljs$devtools$client$node$repl_invoke(p__22927){
var map__22932 = p__22927;
var map__22932__$1 = (((((!((map__22932 == null))))?(((((map__22932.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__22932.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__22932):map__22932);
var msg = map__22932__$1;
var id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22932__$1,new cljs.core.Keyword(null,"id","id",-1388402092));
var result = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(shadow.cljs.devtools.client.env.repl_call(((function (map__22932,map__22932__$1,msg,id){
return (function (){
return shadow.cljs.devtools.client.node.node_eval(msg);
});})(map__22932,map__22932__$1,msg,id))
,shadow.cljs.devtools.client.env.repl_error),new cljs.core.Keyword(null,"id","id",-1388402092),id);
return shadow.cljs.devtools.client.node.ws_msg(result);
});
shadow.cljs.devtools.client.node.repl_set_ns = (function shadow$cljs$devtools$client$node$repl_set_ns(p__22940){
var map__22941 = p__22940;
var map__22941__$1 = (((((!((map__22941 == null))))?(((((map__22941.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__22941.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__22941):map__22941);
var msg = map__22941__$1;
var id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22941__$1,new cljs.core.Keyword(null,"id","id",-1388402092));
return shadow.cljs.devtools.client.node.ws_msg(new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword("repl","set-ns-complete","repl/set-ns-complete",680944662),new cljs.core.Keyword(null,"id","id",-1388402092),id], null));
});
shadow.cljs.devtools.client.node.repl_require = (function shadow$cljs$devtools$client$node$repl_require(p__22944){
var map__22946 = p__22944;
var map__22946__$1 = (((((!((map__22946 == null))))?(((((map__22946.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__22946.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__22946):map__22946);
var msg = map__22946__$1;
var id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22946__$1,new cljs.core.Keyword(null,"id","id",-1388402092));
var sources = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22946__$1,new cljs.core.Keyword(null,"sources","sources",-321166424));
var reload_namespaces = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22946__$1,new cljs.core.Keyword(null,"reload-namespaces","reload-namespaces",250210134));
try{var seq__22954_23231 = cljs.core.seq(sources);
var chunk__22955_23232 = null;
var count__22956_23233 = (0);
var i__22957_23234 = (0);
while(true){
if((i__22957_23234 < count__22956_23233)){
var map__22958_23235 = chunk__22955_23232.cljs$core$IIndexed$_nth$arity$2(null,i__22957_23234);
var map__22958_23236__$1 = (((((!((map__22958_23235 == null))))?(((((map__22958_23235.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__22958_23235.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__22958_23235):map__22958_23235);
var src_23237 = map__22958_23236__$1;
var provides_23238 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22958_23236__$1,new cljs.core.Keyword(null,"provides","provides",-1634397992));
var output_name_23239 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22958_23236__$1,new cljs.core.Keyword(null,"output-name","output-name",-1769107767));
if(cljs.core.truth_((function (){var or__4047__auto__ = (!(shadow.cljs.devtools.client.node.is_loaded_QMARK_(output_name_23239)));
if(or__4047__auto__){
return or__4047__auto__;
} else {
return cljs.core.some(reload_namespaces,provides_23238);
}
})())){
shadow.cljs.devtools.client.node.closure_import(output_name_23239);
} else {
}


var G__23243 = seq__22954_23231;
var G__23244 = chunk__22955_23232;
var G__23245 = count__22956_23233;
var G__23246 = (i__22957_23234 + (1));
seq__22954_23231 = G__23243;
chunk__22955_23232 = G__23244;
count__22956_23233 = G__23245;
i__22957_23234 = G__23246;
continue;
} else {
var temp__5457__auto___23247 = cljs.core.seq(seq__22954_23231);
if(temp__5457__auto___23247){
var seq__22954_23248__$1 = temp__5457__auto___23247;
if(cljs.core.chunked_seq_QMARK_(seq__22954_23248__$1)){
var c__4461__auto___23252 = cljs.core.chunk_first(seq__22954_23248__$1);
var G__23253 = cljs.core.chunk_rest(seq__22954_23248__$1);
var G__23254 = c__4461__auto___23252;
var G__23255 = cljs.core.count(c__4461__auto___23252);
var G__23256 = (0);
seq__22954_23231 = G__23253;
chunk__22955_23232 = G__23254;
count__22956_23233 = G__23255;
i__22957_23234 = G__23256;
continue;
} else {
var map__22984_23257 = cljs.core.first(seq__22954_23248__$1);
var map__22984_23258__$1 = (((((!((map__22984_23257 == null))))?(((((map__22984_23257.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__22984_23257.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__22984_23257):map__22984_23257);
var src_23259 = map__22984_23258__$1;
var provides_23260 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22984_23258__$1,new cljs.core.Keyword(null,"provides","provides",-1634397992));
var output_name_23261 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22984_23258__$1,new cljs.core.Keyword(null,"output-name","output-name",-1769107767));
if(cljs.core.truth_((function (){var or__4047__auto__ = (!(shadow.cljs.devtools.client.node.is_loaded_QMARK_(output_name_23261)));
if(or__4047__auto__){
return or__4047__auto__;
} else {
return cljs.core.some(reload_namespaces,provides_23260);
}
})())){
shadow.cljs.devtools.client.node.closure_import(output_name_23261);
} else {
}


var G__23266 = cljs.core.next(seq__22954_23248__$1);
var G__23267 = null;
var G__23268 = (0);
var G__23269 = (0);
seq__22954_23231 = G__23266;
chunk__22955_23232 = G__23267;
count__22956_23233 = G__23268;
i__22957_23234 = G__23269;
continue;
}
} else {
}
}
break;
}

return shadow.cljs.devtools.client.node.ws_msg(new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword("repl","require-complete","repl/require-complete",-2140254719),new cljs.core.Keyword(null,"id","id",-1388402092),id], null));
}catch (e22953){var e = e22953;
console.error("repl/require failed",e);

return shadow.cljs.devtools.client.node.ws_msg(new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword("repl","require-error","repl/require-error",1689310021),new cljs.core.Keyword(null,"id","id",-1388402092),id], null));
}});
shadow.cljs.devtools.client.node.build_complete = (function shadow$cljs$devtools$client$node$build_complete(p__22988){
var map__22989 = p__22988;
var map__22989__$1 = (((((!((map__22989 == null))))?(((((map__22989.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__22989.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__22989):map__22989);
var msg = map__22989__$1;
var info = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22989__$1,new cljs.core.Keyword(null,"info","info",-317069002));
var reload_info = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22989__$1,new cljs.core.Keyword(null,"reload-info","reload-info",1648088086));
var map__22991 = info;
var map__22991__$1 = (((((!((map__22991 == null))))?(((((map__22991.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__22991.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__22991):map__22991);
var sources = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22991__$1,new cljs.core.Keyword(null,"sources","sources",-321166424));
var compiled = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__22991__$1,new cljs.core.Keyword(null,"compiled","compiled",850043082));
var warnings = cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentVector.EMPTY,cljs.core.distinct.cljs$core$IFn$_invoke$arity$1((function (){var iter__4434__auto__ = ((function (map__22991,map__22991__$1,sources,compiled,map__22989,map__22989__$1,msg,info,reload_info){
return (function shadow$cljs$devtools$client$node$build_complete_$_iter__22994(s__22995){
return (new cljs.core.LazySeq(null,((function (map__22991,map__22991__$1,sources,compiled,map__22989,map__22989__$1,msg,info,reload_info){
return (function (){
var s__22995__$1 = s__22995;
while(true){
var temp__5457__auto__ = cljs.core.seq(s__22995__$1);
if(temp__5457__auto__){
var xs__6012__auto__ = temp__5457__auto__;
var map__23000 = cljs.core.first(xs__6012__auto__);
var map__23000__$1 = (((((!((map__23000 == null))))?(((((map__23000.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__23000.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__23000):map__23000);
var src = map__23000__$1;
var resource_name = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__23000__$1,new cljs.core.Keyword(null,"resource-name","resource-name",2001617100));
var warnings = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__23000__$1,new cljs.core.Keyword(null,"warnings","warnings",-735437651));
if(cljs.core.not(new cljs.core.Keyword(null,"from-jar","from-jar",1050932827).cljs$core$IFn$_invoke$arity$1(src))){
var iterys__4430__auto__ = ((function (s__22995__$1,map__23000,map__23000__$1,src,resource_name,warnings,xs__6012__auto__,temp__5457__auto__,map__22991,map__22991__$1,sources,compiled,map__22989,map__22989__$1,msg,info,reload_info){
return (function shadow$cljs$devtools$client$node$build_complete_$_iter__22994_$_iter__22996(s__22997){
return (new cljs.core.LazySeq(null,((function (s__22995__$1,map__23000,map__23000__$1,src,resource_name,warnings,xs__6012__auto__,temp__5457__auto__,map__22991,map__22991__$1,sources,compiled,map__22989,map__22989__$1,msg,info,reload_info){
return (function (){
var s__22997__$1 = s__22997;
while(true){
var temp__5457__auto____$1 = cljs.core.seq(s__22997__$1);
if(temp__5457__auto____$1){
var s__22997__$2 = temp__5457__auto____$1;
if(cljs.core.chunked_seq_QMARK_(s__22997__$2)){
var c__4432__auto__ = cljs.core.chunk_first(s__22997__$2);
var size__4433__auto__ = cljs.core.count(c__4432__auto__);
var b__22999 = cljs.core.chunk_buffer(size__4433__auto__);
if((function (){var i__22998 = (0);
while(true){
if((i__22998 < size__4433__auto__)){
var warning = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(c__4432__auto__,i__22998);
cljs.core.chunk_append(b__22999,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(warning,new cljs.core.Keyword(null,"resource-name","resource-name",2001617100),resource_name));

var G__23288 = (i__22998 + (1));
i__22998 = G__23288;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons(cljs.core.chunk(b__22999),shadow$cljs$devtools$client$node$build_complete_$_iter__22994_$_iter__22996(cljs.core.chunk_rest(s__22997__$2)));
} else {
return cljs.core.chunk_cons(cljs.core.chunk(b__22999),null);
}
} else {
var warning = cljs.core.first(s__22997__$2);
return cljs.core.cons(cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(warning,new cljs.core.Keyword(null,"resource-name","resource-name",2001617100),resource_name),shadow$cljs$devtools$client$node$build_complete_$_iter__22994_$_iter__22996(cljs.core.rest(s__22997__$2)));
}
} else {
return null;
}
break;
}
});})(s__22995__$1,map__23000,map__23000__$1,src,resource_name,warnings,xs__6012__auto__,temp__5457__auto__,map__22991,map__22991__$1,sources,compiled,map__22989,map__22989__$1,msg,info,reload_info))
,null,null));
});})(s__22995__$1,map__23000,map__23000__$1,src,resource_name,warnings,xs__6012__auto__,temp__5457__auto__,map__22991,map__22991__$1,sources,compiled,map__22989,map__22989__$1,msg,info,reload_info))
;
var fs__4431__auto__ = cljs.core.seq(iterys__4430__auto__(warnings));
if(fs__4431__auto__){
return cljs.core.concat.cljs$core$IFn$_invoke$arity$2(fs__4431__auto__,shadow$cljs$devtools$client$node$build_complete_$_iter__22994(cljs.core.rest(s__22995__$1)));
} else {
var G__23290 = cljs.core.rest(s__22995__$1);
s__22995__$1 = G__23290;
continue;
}
} else {
var G__23291 = cljs.core.rest(s__22995__$1);
s__22995__$1 = G__23291;
continue;
}
} else {
return null;
}
break;
}
});})(map__22991,map__22991__$1,sources,compiled,map__22989,map__22989__$1,msg,info,reload_info))
,null,null));
});})(map__22991,map__22991__$1,sources,compiled,map__22989,map__22989__$1,msg,info,reload_info))
;
return iter__4434__auto__(sources);
})()));
if(((shadow.cljs.devtools.client.env.autoload) && (((cljs.core.empty_QMARK_(warnings)) || (shadow.cljs.devtools.client.env.ignore_warnings))))){
var map__23034 = info;
var map__23034__$1 = (((((!((map__23034 == null))))?(((((map__23034.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__23034.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__23034):map__23034);
var sources__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__23034__$1,new cljs.core.Keyword(null,"sources","sources",-321166424));
var compiled__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__23034__$1,new cljs.core.Keyword(null,"compiled","compiled",850043082));
var files_to_require = cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentVector.EMPTY,cljs.core.map.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"output-name","output-name",-1769107767),cljs.core.filter.cljs$core$IFn$_invoke$arity$2(((function (map__23034,map__23034__$1,sources__$1,compiled__$1,map__22991,map__22991__$1,sources,compiled,warnings,map__22989,map__22989__$1,msg,info,reload_info){
return (function (p__23043){
var map__23044 = p__23043;
var map__23044__$1 = (((((!((map__23044 == null))))?(((((map__23044.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__23044.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__23044):map__23044);
var ns = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__23044__$1,new cljs.core.Keyword(null,"ns","ns",441598760));
var resource_id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__23044__$1,new cljs.core.Keyword(null,"resource-id","resource-id",-1308422582));
return ((cljs.core.contains_QMARK_(compiled__$1,resource_id)) || (cljs.core.contains_QMARK_(new cljs.core.Keyword(null,"always-load","always-load",66405637).cljs$core$IFn$_invoke$arity$1(reload_info),ns)));
});})(map__23034,map__23034__$1,sources__$1,compiled__$1,map__22991,map__22991__$1,sources,compiled,warnings,map__22989,map__22989__$1,msg,info,reload_info))
,cljs.core.remove.cljs$core$IFn$_invoke$arity$2(((function (map__23034,map__23034__$1,sources__$1,compiled__$1,map__22991,map__22991__$1,sources,compiled,warnings,map__22989,map__22989__$1,msg,info,reload_info){
return (function (p__23057){
var map__23059 = p__23057;
var map__23059__$1 = (((((!((map__23059 == null))))?(((((map__23059.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__23059.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__23059):map__23059);
var ns = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__23059__$1,new cljs.core.Keyword(null,"ns","ns",441598760));
return cljs.core.contains_QMARK_(new cljs.core.Keyword(null,"never-load","never-load",1300896819).cljs$core$IFn$_invoke$arity$1(reload_info),ns);
});})(map__23034,map__23034__$1,sources__$1,compiled__$1,map__22991,map__22991__$1,sources,compiled,warnings,map__22989,map__22989__$1,msg,info,reload_info))
,sources__$1))));
if(cljs.core.seq(files_to_require)){
return shadow.cljs.devtools.client.env.do_js_reload.cljs$core$IFn$_invoke$arity$2(msg,((function (map__23034,map__23034__$1,sources__$1,compiled__$1,files_to_require,map__22991,map__22991__$1,sources,compiled,warnings,map__22989,map__22989__$1,msg,info,reload_info){
return (function (){
var seq__23066 = cljs.core.seq(files_to_require);
var chunk__23068 = null;
var count__23069 = (0);
var i__23070 = (0);
while(true){
if((i__23070 < count__23069)){
var src = chunk__23068.cljs$core$IIndexed$_nth$arity$2(null,i__23070);
shadow.cljs.devtools.client.env.before_load_src(src);

shadow.cljs.devtools.client.node.closure_import(src);


var G__23310 = seq__23066;
var G__23311 = chunk__23068;
var G__23312 = count__23069;
var G__23313 = (i__23070 + (1));
seq__23066 = G__23310;
chunk__23068 = G__23311;
count__23069 = G__23312;
i__23070 = G__23313;
continue;
} else {
var temp__5457__auto__ = cljs.core.seq(seq__23066);
if(temp__5457__auto__){
var seq__23066__$1 = temp__5457__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__23066__$1)){
var c__4461__auto__ = cljs.core.chunk_first(seq__23066__$1);
var G__23315 = cljs.core.chunk_rest(seq__23066__$1);
var G__23316 = c__4461__auto__;
var G__23317 = cljs.core.count(c__4461__auto__);
var G__23318 = (0);
seq__23066 = G__23315;
chunk__23068 = G__23316;
count__23069 = G__23317;
i__23070 = G__23318;
continue;
} else {
var src = cljs.core.first(seq__23066__$1);
shadow.cljs.devtools.client.env.before_load_src(src);

shadow.cljs.devtools.client.node.closure_import(src);


var G__23319 = cljs.core.next(seq__23066__$1);
var G__23320 = null;
var G__23321 = (0);
var G__23322 = (0);
seq__23066 = G__23319;
chunk__23068 = G__23320;
count__23069 = G__23321;
i__23070 = G__23322;
continue;
}
} else {
return null;
}
}
break;
}
});})(map__23034,map__23034__$1,sources__$1,compiled__$1,files_to_require,map__22991,map__22991__$1,sources,compiled,warnings,map__22989,map__22989__$1,msg,info,reload_info))
);
} else {
return null;
}
} else {
return null;
}
});
shadow.cljs.devtools.client.node.process_message = (function shadow$cljs$devtools$client$node$process_message(p__23096){
var map__23097 = p__23096;
var map__23097__$1 = (((((!((map__23097 == null))))?(((((map__23097.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__23097.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__23097):map__23097);
var msg = map__23097__$1;
var type = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__23097__$1,new cljs.core.Keyword(null,"type","type",1174270348));
var G__23104 = type;
var G__23104__$1 = (((G__23104 instanceof cljs.core.Keyword))?G__23104.fqn:null);
switch (G__23104__$1) {
case "repl/init":
return shadow.cljs.devtools.client.node.repl_init(msg);

break;
case "repl/invoke":
return shadow.cljs.devtools.client.node.repl_invoke(msg);

break;
case "repl/set-ns":
return shadow.cljs.devtools.client.node.repl_set_ns(msg);

break;
case "repl/require":
return shadow.cljs.devtools.client.node.repl_require(msg);

break;
case "build-configure":
return new cljs.core.Keyword(null,"ignored","ignored",1227374526);

break;
case "build-start":
return new cljs.core.Keyword(null,"ignored","ignored",1227374526);

break;
case "build-complete":
return shadow.cljs.devtools.client.node.build_complete(msg);

break;
case "build-failure":
return new cljs.core.Keyword(null,"ignored","ignored",1227374526);

break;
case "worker-shutdown":
return cljs.core.deref(shadow.cljs.devtools.client.node.ws_ref).terminate();

break;
default:
return cljs.core.prn.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"repl-unknown","repl-unknown",-1898463611),msg], null)], 0));

}
});
shadow.cljs.devtools.client.node.ws_connect = (function shadow$cljs$devtools$client$node$ws_connect(){
var url = shadow.cljs.devtools.client.env.ws_url(new cljs.core.Keyword(null,"node","node",581201198));
var client = (new shadow.js.shim.module$ws(url,cljs.core.PersistentVector.EMPTY));
client.on("open",(function (){
return cljs.core.vreset_BANG_(shadow.cljs.devtools.client.node.ws_ref,client);
}));

client.on("unexpected-response",(function (req,res){
var status = res.statusCode;
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((406),status)){
return console.log("REPL connection rejected, probably stale JS connecting to new server.");
} else {
return console.log("REPL unexpected error",res.statusCode);
}
}));

client.on("message",(function (data,flags){
try{return shadow.cljs.devtools.client.env.process_ws_msg(data,shadow.cljs.devtools.client.node.process_message);
}catch (e23364){var e = e23364;
return console.error("failed to process message",data,e);
}}));

client.on("close",(function (){
return console.log("REPL client disconnected");
}));

return client.on("error",(function (err){
return console.log("REPL client error",err);
}));
});
if(shadow.cljs.devtools.client.env.enabled){
shadow.cljs.devtools.client.node.ws_close();

shadow.cljs.devtools.client.node.ws_connect();
} else {
}

module.exports = shadow.cljs.devtools.client.node;

//# sourceMappingURL=shadow.cljs.devtools.client.node.js.map
