"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const vscode = require("vscode");
const formatter = require("../format");
const docmirror_1 = require("../docmirror");
class FormatOnTypeEditProvider {
    provideOnTypeFormattingEdits(document, position, _ch, _options) {
        return __awaiter(this, void 0, void 0, function* () {
            if (vscode.workspace.getConfiguration("calva.fmt").get("formatAsYouType")) {
                if (vscode.workspace.getConfiguration("calva.fmt").get("newIndentEngine")) {
                    let editor = vscode.window.activeTextEditor;
                    let pos = new vscode.Position(position.line, 0);
                    let indent = docmirror_1.getIndent(document, pos);
                    let delta = document.lineAt(position.line).firstNonWhitespaceCharacterIndex - indent;
                    if (delta > 0) {
                        //return [vscode.TextEdit.delete(new vscode.Range(pos, new vscode.Position(pos.line, delta)))];
                        editor.edit(edits => edits.delete(new vscode.Range(pos, new vscode.Position(pos.line, delta))), { undoStopAfter: false, undoStopBefore: false });
                    }
                    else if (delta < 0) {
                        let str = "";
                        while (delta++ < 0)
                            str += " ";
                        //return [vscode.TextEdit.insert(pos, str)];
                        editor.edit(edits => edits.insert(pos, str), { undoStopAfter: false, undoStopBefore: false });
                    }
                }
                else {
                    formatter.formatPosition(vscode.window.activeTextEditor, true);
                }
            }
            return null;
        });
    }
}
exports.FormatOnTypeEditProvider = FormatOnTypeEditProvider;
//# sourceMappingURL=ontype_formatter.js.map