"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const _ = require("lodash");
const edn = require("jsedn");
const state = require("./state");
const util = require("./utilities");
function shadowNReplPortFile() {
    return util.getProjectDir() + '/.shadow-cljs/nrepl.port';
}
function shadowConfigFile() {
    return util.getProjectDir() + '/shadow-cljs.edn';
}
function isShadowCljs() {
    return fs.existsSync(shadowNReplPortFile());
}
function shadowBuilds() {
    let parsed = edn.parse(fs.readFileSync(shadowConfigFile(), 'utf8').toString()), keys = parsed.at(edn.kw(':builds')).keys, builds = _.map(keys, 'name');
    builds.push("node-repl");
    builds.push("browser-repl");
    return builds;
}
function shadowBuild() {
    return state.deref().get('shadowBuild');
}
exports.default = {
    isShadowCljs,
    shadowNReplPortFile,
    shadowBuilds,
    shadowBuild
};
//# sourceMappingURL=shadow.js.map