'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const vscode_1 = require("vscode");
const activeColour = "white";
const inactiveColour = "#b3b3b3";
const colour = { "active": "white", "inactive": "#b3b3b3" };
class StatusBar {
    constructor(enabled = true, strict = true, visible = true) {
        this._toggleBarItem = vscode_1.window.createStatusBarItem(vscode_1.StatusBarAlignment.Right);
        this._toggleBarItem.text = "(λ)";
        this._toggleBarItem.command = 'paredit.toggle';
        this.enabled = enabled;
        this.visible = visible;
        this.visible = visible;
    }
    get enabled() {
        return this._enabled;
    }
    set enabled(value) {
        this._enabled = value;
        if (this._enabled) {
            this._toggleBarItem.tooltip = "Disable Paredit";
            this._toggleBarItem.color = colour.active;
        }
        else {
            this._toggleBarItem.tooltip = "Enable Paredit";
            this._toggleBarItem.color = colour.inactive;
        }
    }
    get visible() {
        return this._visible;
    }
    set visible(value) {
        if (value) {
            this._toggleBarItem.show();
        }
        else {
            this._toggleBarItem.hide();
        }
    }
    dispose() {
        this._toggleBarItem.dispose();
    }
}
exports.StatusBar = StatusBar;
//# sourceMappingURL=status_bar.js.map