"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const vscode = require("vscode");
const state = require("../state");
const util = require("../utilities");
class DefinitionProvider {
    constructor() {
        this.state = state;
    }
    provideDefinition(document, position, token) {
        return __awaiter(this, void 0, void 0, function* () {
            let text = util.getWordAtPosition(document, position);
            let client = util.getSession(util.getFileType(document));
            if (this.state.deref().get('connected')) {
                let info = yield client.info(util.getNamespace(document.getText()), text);
                if (info.file && info.file.length > 0) {
                    let pos = new vscode.Position(info.line - 1, info.column);
                    return new vscode.Location(vscode.Uri.parse(info.file), pos);
                }
            }
        });
    }
}
exports.default = DefinitionProvider;
;
//# sourceMappingURL=definition.js.map