"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const vscode = require("vscode");
const Immutable = require("immutable");
const ImmutableCursor = require("immutable-cursor");
let extensionContext;
exports.extensionContext = extensionContext;
function setExtensionContext(context) {
    exports.extensionContext = extensionContext = context;
}
exports.setExtensionContext = setExtensionContext;
const mode = {
    language: 'clojure',
};
exports.mode = mode;
var data;
const initialData = {
    hostname: null,
    port: null,
    clj: null,
    cljs: null,
    shadowBuild: null,
    terminal: null,
    connected: false,
    connecting: false,
    outputChannel: vscode.window.createOutputChannel("Calva says"),
    diagnosticCollection: vscode.languages.createDiagnosticCollection('calva: Evaluation errors')
};
reset();
const cursor = ImmutableCursor.from(data, [], (nextState) => {
    data = Immutable.fromJS(nextState);
});
exports.cursor = cursor;
function deref() {
    return data;
}
exports.deref = deref;
function reset() {
    data = Immutable.fromJS(initialData);
}
exports.reset = reset;
function config() {
    let configOptions = vscode.workspace.getConfiguration('calva'), projectRootDirectoryConfig = configOptions.get("projectRootDirectory");
    return {
        format: configOptions.get("formatOnSave"),
        evaluate: configOptions.get("evalOnSave"),
        lint: configOptions.get("lintOnSave"),
        test: configOptions.get("testOnSave"),
        autoConnect: configOptions.get("autoConnect"),
        connectREPLCommand: configOptions.get("connectREPLCommand"),
        projectRootDirectory: projectRootDirectoryConfig.replace(/^\/|\/$/g, ""),
        jokerPath: configOptions.get("jokerPath"),
        useJokerOnWSL: configOptions.get("useJokerOnWSL"),
        syncReplNamespaceToCurrentFile: configOptions.get("syncReplNamespaceToCurrentFile")
    };
}
exports.config = config;
//# sourceMappingURL=state.js.map